From ec4fda08a8994d41403b83991d8654dd721e256e Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 06 2020 00:55:27 +0000
Subject: [PATCH 1295/2232] Store Cargo links attribute with Project


---

diff --git a/gen/build/src/lib.rs b/gen/build/src/lib.rs
index 8097dec..81b7690 100644
--- a/gen/build/src/lib.rs
+++ b/gen/build/src/lib.rs
@@ -114,6 +114,8 @@ pub fn bridges(rust_source_files: impl IntoIterator<Item = impl AsRef<Path>>) ->
 struct Project {
     include_prefix: PathBuf,
     manifest_dir: PathBuf,
+    // The `links = "..."` value from Cargo.toml.
+    links_attribute: Option<OsString>,
     // Output directory as received from Cargo.
     out_dir: PathBuf,
     // Directory into which to symlink all generated code.
@@ -137,6 +139,8 @@ impl Project {
         assert!(include_prefix.is_relative());
         let include_prefix = include_prefix.components().collect();
 
+        let links_attribute = env::var_os("CARGO_MANIFEST_LINKS");
+
         let manifest_dir = paths::manifest_dir()?;
         let out_dir = paths::out_dir()?;
 
@@ -148,6 +152,7 @@ impl Project {
         Ok(Project {
             include_prefix,
             manifest_dir,
+            links_attribute,
             out_dir,
             shared_dir,
         })
@@ -226,7 +231,7 @@ fn make_this_crate(prj: &Project) -> Result<Crate> {
 
     let mut this_crate = Crate {
         include_prefix: Some(prj.include_prefix.clone()),
-        links: env::var_os("CARGO_MANIFEST_LINKS"),
+        links: prj.links_attribute.clone(),
         header_dirs: Vec::new(),
     };
 

